using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using Exferia_General;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_NomenclaturasPrecios_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo> g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_NomenclaturasPrecios).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if((g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo != null) && (g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_NomenclaturasPrecios).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if((g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo != null) && (g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                    " SELECT " +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.id) + " = " + nameof(MAE_NomenclaturasPrecios.id) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.codigo) + " = " + nameof(MAE_NomenclaturasPrecios.codigo) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.descripcion) + " = " + nameof(MAE_NomenclaturasPrecios.descripcion) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.actualizarPreciosCompras_Cuando) + " = " + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Cuando) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.actualizarPreciosCompras_Preguntar) + " = " + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Preguntar) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.actualizarPreciosCompras_Tipo) + " = " + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Tipo) +
                " FROM " + nameof(MAE_NomenclaturasPrecios) +
                " WHERE " + nameof(MAE_NomenclaturasPrecios.fechaBorrado) + " IS null AND " +
                        (_lng_id > -1 ? (nameof(MAE_NomenclaturasPrecios.id) + "=@id") : "1 = 1");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region  F3 
        private INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo g_mdl_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_NomenclaturasPrecios).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if(g_mdl_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_NomenclaturasPrecios).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if(g_mdl_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }      
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                    " SELECT distinct " +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.id) + " = " + nameof(MAE_NomenclaturasPrecios.id) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.codigo) + " = " + nameof(MAE_NomenclaturasPrecios.codigo) + "," +
                        nameof(INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo.descripcion) + " = " + nameof(MAE_NomenclaturasPrecios.descripcion) +
                " FROM " + nameof(MAE_NomenclaturasPrecios) +
                " WHERE " + nameof(MAE_NomenclaturasPrecios.fechaBorrado) + " IS null AND " +
                        (
                         (_lng_id > -1)
                          ? (nameof(MAE_NomenclaturasPrecios.id) + " = " + _lng_id)
                          : (
                                //Filtrar por Codigo
                                (_str_CampoBusqueda.Equals(nameof(MAE_NomenclaturasPrecios.codigo)))
                                    ? (nameof(MAE_NomenclaturasPrecios.codigo) + "=@Filtro")
                                    //Filtrar por Descripcion
                                    : (nameof(MAE_NomenclaturasPrecios.descripcion) + "=@Filtro")
                            )
                        );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_NomenclaturasPrecios_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT distinct " +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.id) + "," +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.codigo) + "," +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.descripcion) + "," +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Cuando) + "," +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Preguntar) + "," +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Tipo) + "," +
                       nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.fechaBorrado) +
               " FROM " + nameof(MAE_NomenclaturasPrecios) +
               " WHERE " + nameof(MAE_NomenclaturasPrecios.fechaBorrado) + " IS null AND " +
                           nameof(MAE_NomenclaturasPrecios.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_NomenclaturasPrecios>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_NomenclaturasPrecios g_mdl_MAE_NomenclaturasPrecios = null;
        public MAE_NomenclaturasPrecios Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_NomenclaturasPrecios;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MAE_NomenclaturasPrecios = obj_Exferia_Entities.Database.SqlQuery<MAE_NomenclaturasPrecios>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelos Listado
        private List<MAE_NomenclaturasPrecios> g_lst_MAE_NomenclaturasPrecios = null;

        public List<MAE_NomenclaturasPrecios> Obtener_ModeloListado()
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                //WHERE
                                " WHERE " + nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.fechaBorrado) + " IS NULL ";

                //Parametros
                object[] arr_Parametros = new object[1];

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL, 
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_ModeloListado), true);
            }

            return g_lst_MAE_NomenclaturasPrecios;
        }

        public List<MAE_NomenclaturasPrecios> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MAE_NomenclaturasPrecios),
                                                                                            nameof(MAE_NomenclaturasPrecios.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MAE_NomenclaturasPrecios;
        }

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                       object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_NomenclaturasPrecios = obj_Exferia_Entities.Database.SqlQuery<MAE_NomenclaturasPrecios>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.id) + " , " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.codigo) + " , " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.descripcion) + " , " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Cuando) + " , " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Preguntar) + " , " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Tipo) + " , " +
                    nameof(MAE_NomenclaturasPrecios) + "." + nameof(MAE_NomenclaturasPrecios.fechaBorrado) +
                " FROM " + nameof(MAE_NomenclaturasPrecios);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MAE_NomenclaturasPrecios mdl_MAE_NomenclaturasPrecios_AGrabar = (MAE_NomenclaturasPrecios)_mdl_obj;
                MAE_NomenclaturasPrecios mdl_MAE_NomenclaturasPrecios_DatosViejos = new MAE_NomenclaturasPrecios();

                // Ver si existe ######################################################################
                MAE_NomenclaturasPrecios mdl_MAE_NomenclaturasPrecios_Final = Obtener_Modelo_Por_Id(mdl_MAE_NomenclaturasPrecios_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_MAE_NomenclaturasPrecios_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_NomenclaturasPrecios_Final, mdl_MAE_NomenclaturasPrecios_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_NomenclaturasPrecios_AGrabar, mdl_MAE_NomenclaturasPrecios_Final, false, false);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_NomenclaturasPrecios) +
                                            " SET " +
                                                nameof(MAE_NomenclaturasPrecios.codigo) + "=@codigo," +
                                                nameof(MAE_NomenclaturasPrecios.descripcion) + "=@descripcion," +
                                                nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Cuando) + "=@actualizarPreciosCompras_Cuando," +
                                                nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Preguntar) + "=@actualizarPreciosCompras_Preguntar," +
                                                nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Tipo) + "=@actualizarPreciosCompras_Tipo" +
                                            " WHERE " +
                                                nameof(MAE_NomenclaturasPrecios.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MAE_NomenclaturasPrecios_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_MAE_NomenclaturasPrecios_AGrabar.descripcion),
                        new SqlParameter("@actualizarPreciosCompras_Cuando",  mdl_MAE_NomenclaturasPrecios_AGrabar.actualizarPreciosCompras_Cuando),
                        new SqlParameter("@actualizarPreciosCompras_Preguntar",  mdl_MAE_NomenclaturasPrecios_AGrabar.actualizarPreciosCompras_Preguntar),
                        new SqlParameter("@actualizarPreciosCompras_Tipo",  mdl_MAE_NomenclaturasPrecios_AGrabar.actualizarPreciosCompras_Tipo),
                        new SqlParameter("@id",  mdl_MAE_NomenclaturasPrecios_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_NomenclaturasPrecios_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_NomenclaturasPrecios_Final = new MAE_NomenclaturasPrecios();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_NomenclaturasPrecios_AGrabar, mdl_MAE_NomenclaturasPrecios_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_NomenclaturasPrecios) +
                                               " (" +
                                                       nameof(MAE_NomenclaturasPrecios.codigo) + "," +
                                                       nameof(MAE_NomenclaturasPrecios.descripcion) + "," +
                                                       nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Cuando) + "," +
                                                       nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Preguntar) + "," +
                                                       nameof(MAE_NomenclaturasPrecios.actualizarPreciosCompras_Tipo) + "," +
                                                       nameof(MAE_NomenclaturasPrecios.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MAE_NomenclaturasPrecios.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@actualizarPreciosCompras_Cuando," +
                                                   "@actualizarPreciosCompras_Preguntar," +
                                                   "@actualizarPreciosCompras_Tipo," +
                                                   "@fechaBorrado" +
                                               " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                         new SqlParameter("@codigo",  mdl_MAE_NomenclaturasPrecios_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_MAE_NomenclaturasPrecios_AGrabar.descripcion),
                        new SqlParameter("@actualizarPreciosCompras_Cuando",  mdl_MAE_NomenclaturasPrecios_AGrabar.actualizarPreciosCompras_Cuando),
                        new SqlParameter("@actualizarPreciosCompras_Preguntar",  mdl_MAE_NomenclaturasPrecios_AGrabar.actualizarPreciosCompras_Preguntar),
                        new SqlParameter("@actualizarPreciosCompras_Tipo",  mdl_MAE_NomenclaturasPrecios_AGrabar.actualizarPreciosCompras_Tipo),
                        mdl_MAE_NomenclaturasPrecios_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_NomenclaturasPrecios_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_NomenclaturasPrecios), mdl_MAE_NomenclaturasPrecios_DatosViejos, mdl_MAE_NomenclaturasPrecios_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_NomenclaturasPrecios mdl_MAE_NomenclaturasPrecios_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MAE_NomenclaturasPrecios_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_NomenclaturasPrecios) +
                                                " SET " +
                                                nameof(MAE_NomenclaturasPrecios.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_NomenclaturasPrecios.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_NomenclaturasPrecios), null, mdl_MAE_NomenclaturasPrecios_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);

                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_NomenclaturasPrecios) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
